CON 
        _clkmode = xtal1 + pll16x
        _XinFREQ = 5_000_000

        Pin  = 0

        Frequency = 22                                    'DC to 128MHz
OBJ
        txt   : "TV_Text"
        Freq1 : "Synth"
        probe : "MonitorPWM"
        
VAR
        long ctr, frq
        long Tach1[5], Tach2[10], tach3
        Long TachA, TachB, TachC
        long tHprobe, tlprobe, pulseCnt
        
PUB Go | freq,freq2, i,j,k

       'initilize cogs
    
       txt.start(12)        
       cognew(@entry, @freq)  
       probe.start(4, @tHprobe, @tLprobe, @pulseCnt)
        
       Freq1.Synth("A",Pin, Frequency)
       i := 0
       j := 0
       k := 0
       tach3 := 0
               
        repeat
          Tach1[i] := freq
          Tach2[j] := freq
          Tach3 := (tach3 + freq)/2                                        
          TachA := (Tach1[0] + Tach1[1] + Tach1[2] + Tach1[3] + Tach1[4])/5
          TachB := (Tach1[0] + Tach1[1] + Tach1[2] + Tach1[3] + Tach1[4]+Tach1[5] + Tach1[6] + Tach1[7] + Tach1[8] + Tach1[9])/10
          txt.out($00)                  'clear the screen
          txt.dec(Freq)
          txt.out($0D) 
          txt.dec((freq*600))                 'display the value (in Hz)  
          txt.out($0D)
          txt.dec((TachA*600))
          txt.out($0D)
          txt.dec((TachB*600))
          txt.out($0D)
          txt.dec((Tach3*600))
                           
          txt.out($0D)
          txt.out($0D)
          txt.dec((tHprobe))
          txt.out($0D)
          txt.dec((tLprobe))
          txt.out($0D)
          txt.dec((pulseCnt))
          
          i := i + 1
          j := j + 1

          if i == 5
             i := 0
          if j == 10
             j := 0

          pauseVideo(30)
          
PRI PauseVideo(MS)

    waitcnt(((ClkFREQ/2000)*MS)+cnt)
    
DAT
        org
                 
entry   mov     ctra, ctra_             'establish mode and start counter
        mov     frqa, #1                'increment for each edge seen
        mov     cnt_, cnt               'setup time delay
        add     cnt_, cntadd

:loop   waitcnt cnt_, cntadd            'wait for next sample
        mov     new, phsa               'record new count
        mov     temp, new               'make second copy
        sub     new, old                'get delta
        mov     old, temp               'set next delta's base

        wrlong  new, par
        jmp     #:loop

ctra_   long    %01010 << 26 + 7        'mode + APIN
cntadd  long    8_000_000              'wait 1 second, answer in Hz 

cnt_    res     1
new     res     1
old     res     1
temp    res     1
          